# Class VulkanLogicalDeviceCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanLogicalDeviceCreateInfo

All Implemented Interfaces:
  `VulkanLogicalDeviceCreateInfoType`

public final class VulkanLogicalDeviceCreateInfo extends Object implements VulkanLogicalDeviceCreateInfoType
Parameters used to create logical devices.

See Also:
  - "VkDeviceCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanLogicalDeviceCreateInfo.Builder`
  Builds instances of type `VulkanLogicalDeviceCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanLogicalDeviceCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanLogicalDeviceCreateInfo`.
  `static VulkanLogicalDeviceCreateInfo`
  `copyOf(VulkanLogicalDeviceCreateInfoType instance)`
  Creates an immutable copy of a `VulkanLogicalDeviceCreateInfoType` value.
  `List<String>`
  `enabledExtensions()`
  `List<String>`
  `enabledLayers()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanLogicalDeviceCreateInfo` that have equal attribute values.
  `Optional<VulkanPhysicalDeviceFeatures>`
  `features()`
  `Set<VulkanLogicalDeviceCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `queueCreateInfos`, `enabledLayers`, `enabledExtensions`, `features`.
  `List<VulkanLogicalDeviceQueueCreateInfo>`
  `queueCreateInfos()`
  `String`
  `toString()`
  Prints the immutable value `VulkanLogicalDeviceCreateInfo` with attribute values.
  `final VulkanLogicalDeviceCreateInfo`
  `withEnabledExtensions(Iterable<String> elements)`
  Copy the current immutable object with elements that replace the content of `enabledExtensions`.
  `final VulkanLogicalDeviceCreateInfo`
  `withEnabledExtensions(String... elements)`
  Copy the current immutable object with elements that replace the content of `enabledExtensions`.
  `final VulkanLogicalDeviceCreateInfo`
  `withEnabledLayers(Iterable<String> elements)`
  Copy the current immutable object with elements that replace the content of `enabledLayers`.
  `final VulkanLogicalDeviceCreateInfo`
  `withEnabledLayers(String... elements)`
  Copy the current immutable object with elements that replace the content of `enabledLayers`.
  `final VulkanLogicalDeviceCreateInfo`
  `withFeatures(VulkanPhysicalDeviceFeatures value)`
  Copy the current immutable object by setting a present value for the optional `features` attribute.
  `final VulkanLogicalDeviceCreateInfo`
  `withFeatures(Optional<? extends VulkanPhysicalDeviceFeatures> optional)`
  Copy the current immutable object by setting an optional value for the `features` attribute.
  `final VulkanLogicalDeviceCreateInfo`
  `withFlags(VulkanLogicalDeviceCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanLogicalDeviceCreateInfo`
  `withFlags(Iterable<VulkanLogicalDeviceCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanLogicalDeviceCreateInfo`
  `withQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo... elements)`
  Copy the current immutable object with elements that replace the content of `queueCreateInfos`.
  `final VulkanLogicalDeviceCreateInfo`
  `withQueueCreateInfos(Iterable<? extends VulkanLogicalDeviceQueueCreateInfo> elements)`
  Copy the current immutable object with elements that replace the content of `queueCreateInfos`.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanLogicalDeviceCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanLogicalDeviceCreateInfoType`
    Returns:
      The creation flags

  - ### queueCreateInfos

    public List<VulkanLogicalDeviceQueueCreateInfo> queueCreateInfos()
    Specified by:
      `queueCreateInfos` in interface `VulkanLogicalDeviceCreateInfoType`
    Returns:
      A list of queues to be created

  - ### enabledLayers

    public List<String> enabledLayers()
    Specified by:
      `enabledLayers` in interface `VulkanLogicalDeviceCreateInfoType`
    Returns:
      A list of layers to be enabled

  - ### enabledExtensions

    public List<String> enabledExtensions()
    Specified by:
      `enabledExtensions` in interface `VulkanLogicalDeviceCreateInfoType`
    Returns:
      A list of extensions to be enabled

  - ### features

    public Optional<VulkanPhysicalDeviceFeatures> features()
    Specified by:
      `features` in interface `VulkanLogicalDeviceCreateInfoType`
    Returns:
      A set of features to be enabled

  - ### withFlags

    public final VulkanLogicalDeviceCreateInfo withFlags(VulkanLogicalDeviceCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanLogicalDeviceCreateInfo withFlags(Iterable<VulkanLogicalDeviceCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withQueueCreateInfos

    public final VulkanLogicalDeviceCreateInfo withQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo... elements)
    Copy the current immutable object with elements that replace the content of `queueCreateInfos`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withQueueCreateInfos

    public final VulkanLogicalDeviceCreateInfo withQueueCreateInfos(Iterable<? extends VulkanLogicalDeviceQueueCreateInfo> elements)
    Copy the current immutable object with elements that replace the content of `queueCreateInfos`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of queueCreateInfos elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withEnabledLayers

    public final VulkanLogicalDeviceCreateInfo withEnabledLayers(String... elements)
    Copy the current immutable object with elements that replace the content of `enabledLayers`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withEnabledLayers

    public final VulkanLogicalDeviceCreateInfo withEnabledLayers(Iterable<String> elements)
    Copy the current immutable object with elements that replace the content of `enabledLayers`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of enabledLayers elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withEnabledExtensions

    public final VulkanLogicalDeviceCreateInfo withEnabledExtensions(String... elements)
    Copy the current immutable object with elements that replace the content of `enabledExtensions`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withEnabledExtensions

    public final VulkanLogicalDeviceCreateInfo withEnabledExtensions(Iterable<String> elements)
    Copy the current immutable object with elements that replace the content of `enabledExtensions`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of enabledExtensions elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withFeatures

    public final VulkanLogicalDeviceCreateInfo withFeatures(VulkanPhysicalDeviceFeatures value)
    Copy the current immutable object by setting a present value for the optional `features` attribute.
    Parameters:
      `value` - The value for features
    Returns:
      A modified copy or `this` if not changed

  - ### withFeatures

    public final VulkanLogicalDeviceCreateInfo withFeatures(Optional<? extends VulkanPhysicalDeviceFeatures> optional)
    Copy the current immutable object by setting an optional value for the `features` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for features
    Returns:
      A modified copy or `this` if not changed

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanLogicalDeviceCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `queueCreateInfos`, `enabledLayers`, `enabledExtensions`, `features`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanLogicalDeviceCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanLogicalDeviceCreateInfo copyOf(VulkanLogicalDeviceCreateInfoType instance)
    Creates an immutable copy of a `VulkanLogicalDeviceCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanLogicalDeviceCreateInfo instance

  - ### builder

    public static VulkanLogicalDeviceCreateInfo.Builder builder()
    Creates a builder for `VulkanLogicalDeviceCreateInfo`.

        VulkanLogicalDeviceCreateInfo.builder()
           .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanLogicalDeviceCreateFlag) // flags elements
           .addQueueCreateInfos|addAllQueueCreateInfos(VulkanLogicalDeviceQueueCreateInfo) // queueCreateInfos elements
           .addEnabledLayers|addAllEnabledLayers(String) // enabledLayers elements
           .addEnabledExtensions|addAllEnabledExtensions(String) // enabledExtensions elements
           .setFeatures(Optional<VulkanPhysicalDeviceFeatures>) // optional features
           .build();

    Returns:
      A new VulkanLogicalDeviceCreateInfo builder